#ifndef _INCLUDE_CON_BUF_H
#define _INCLUDE_CON_BUF_H

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

typedef struct {
  int maxrow;     // max rows
  int maxcol;     // max columns
  int row;        // current row
  int col;        // current col
  int size;       // size of console in bytes
	int changed;     // set to TRUE if changed
  char * dataptr; // pointer to console data
} CONBUFFER_T;

void __stdcall conbuf_clear( CONBUFFER_T conbuffer );
void __stdcall conbuf_text( CONBUFFER_T conbuffer, char * txt );
int __stdcall conbuf_resize( CONBUFFER_T conbuffer, int rows, int cols );

#endif
