#ifndef __INCLUDE_JM_FONT_BI__
#define __INCLUDE_JM_FONT_BI__





enum JM_FONT_TYPES
	JM_FONT_TYPE_BITMAP = 0
	JM_FONT_TYPE_VARBITMAP = 1
	JM_FONT_TYPE_TTF = 2
end enum

#ifndef JM_FONT_PTR_DEFINED
#define JM_FONT_PTR_DEFINED
Type JM_FONT_PTR as Any Ptr
#endif

Declare Function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
Declare Function FONT_CreateFromBMP alias "FONT_CreateFromBMP" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
Declare Function FONT_CreateFromTTF alias "FONT_CreateFromTTF" (ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
Declare Function FONT_CreateFromFNT alias "FONT_CreateFromFNT" (byval strFile As zString ptr) As JM_FONT_PTR

Declare Function FONT_Get alias "FONT_Get" () As JM_FONT_PTR
Declare Function FONT_Set alias "FONT_Set" (byval fnt As JM_FONT_PTR) As JM_FONT_PTR
Declare Sub FONT_Delete alias "FONT_Delete" (byval fnt As JM_FONT_PTR)

Declare Function FONT_GetTextWidthN alias "FONT_GetTextWidthN" (ByVal s As ubyte Ptr, ByVal nBytes As Integer) As Integer
Declare Function FONT_GetTextWidth alias "FONT_GetTextWidth" (byval s as zstring ptr) As Integer

Declare Function FONT_GetTextHeightN alias "FONT_GetTextHeightN" (ByVal s As ubyte Ptr, ByVal nBytes As Integer) As Integer
Declare Function FONT_GetTextHeight alias "FONT_GetTextHeight" (byval s as zstring ptr) As Integer

Declare Function FONT_GetCharAdvanceX alias "FONT_GetCharAdvanceX" (byval ch as integer) As Integer
Declare Function FONT_GetCharAdvanceY alias "FONT_GetCharAdvanceY" (byval ch as integer) As Integer

Declare Function FONT_GetIndexFromX alias "FONT_GetIndexFromX" (Byval s as uByte Ptr, ByVal nBytes as integer, ByVal StartIndex as integer, ByVal xPos as integer) as integer
Declare Function FONT_GetMaxChars alias "FONT_GetMaxChars" (Byval s as uByte Ptr, ByVal nBytes as integer, byval w as integer ) as integer

Declare Function FONT_DrawChar alias "FONT_DrawChar"  (ByVal x as Integer, ByVal y as Integer, _
	ByVal ch as Integer, _
	ByVal foreColor as Integer, ByVal backColor as Integer, ByVal Trans as integer) as integer

Declare Function FONT_DrawStringN alias "FONT_DrawStringN" (ByVal x as Integer, ByVal y as Integer, _ 
	ByVal txt as zstring Ptr, ByVal nBytes As Integer, _
	ByVal foreColor as Integer, ByVal backColor as Integer, ByVal Trans as integer) as integer

Declare Function FONT_DrawString alias "FONT_DrawString" (ByVal x as Integer, ByVal y as Integer, _ 
	ByVal txt as zstring Ptr, _
	ByVal foreColor as Integer, ByVal backColor as Integer, ByVal Trans as integer) as integer

Extern FONT_curfnt As JM_FONT_PTR

#endif
