''  jm_boxes_color.bas - jm_gui
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Option Explicit
#include "../jm_hack/jm_hack.bi"

''#define UI_SYSCLR_FRAME_FACE    = 1
''#define UI_SYSCLR_FRAME_HIGH    = 2
''#define UI_SYSCLR_FRAME_SHADOW  = 3
''#define UI_SYSCLR_FRAME_OUTLINE = 4
''#define UI_SYSCLR_TEXT          = 5
''#define UI_STSCLR_TEXT_BACK     = 6

Dim Shared SysColor8(0 to 7)  = { 0, 7, 15, 0, 0, 0, 15, 0 }

Dim Shared SysColor24(0 to 7) = { RGB(0,0,0), _
                                  RGB(127,127,191), _
                                  RGB(255,255,255), _
																	RGB(0,0,0), _
																	RGB(0,0,0), _
																	RGB(255,255,255), _
																	RGB(0,0,0), _
																	RGB(0,0,0) }

dim shared sysColors as integer ptr

dim shared palettebuffer(0 to 255) as integer

BEGIN_CTOR(jm_boxes_color_init)
''private sub jm_boxes_color_init() constructor
	sysColors = @SysColor24(0)
	EMIT_GLOBAL_CTOR(jm_boxes_color_init)
END_CTOR

Sub UI_SetColorDepth alias "UI_SetColorDepth" (byval bitdepth as integer)
	dim i as integer
	select case bitdepth
	case 8
		sysColors = @SysColor8(0)
		for i = 0 to 7
	  	'palette SysColor8(i),SysColor24(i) 
		next i
	case else																																		 
		sysColors = @SysColor24(0)
	end select
end sub

Function UI_GetSysColor alias "UI_GetSysColor" (byval index as integer) as integer
	if sysColors then
		function = sysColors[index and 7]
	endif
End Function

Sub UI_SetSysColor alias "UI_SetSysColor" (byval index as integer, byval clr as integer)
	if sysColors then
		sysColors[index and 7] = clr
	endif
End sub
