#ifndef __INCLUDE_JM_STRING_H__
#define __INCLUDE_JM_STRING_H__

#ifndef NULL
#define NULL 0
#endif

char * zstr_Alloc(int size);
char * zstr_Free(char * s);
int    zstr_Len(char * s);
char * zstr_Copy(char * dst, char * src);
char * zstr_CopyN(char * dst, char * src, int size);

typedef char * DSTR;
void dstr_Free(DSTR p);
DSTR dstr_AllocNew(int maxsize);
DSTR dstr_AllocCopyZ(char * s);
DSTR dstr_AssignZ(DSTR p, char * s);

void mstr_Copy(void * dst, void * src, int bytes);
void mstr_Move(void * dst, void * src, int bytes);
void mstr_Clear(void * dst, int bytes);
void mstr_Fill(void * dst, int bytes, int ch);

#endif
