#ifndef _INCLUDE_JM_CON_H
#define _INCLUDE_JM_CON_H

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

#define CON_DEBUG_ENABLE    1
#define CON_DEBUG_REDIR     2
#define CON_DEBUG_BOTH      4

int __stdcall CON_getecho( void );
int __stdcall CON_setecho( int echo );
int __stdcall CON_getdebug( void );
int __stdcall CON_setdebug( int flag );
void __stdcall CON_setlogfile( const char * f );
const char * __stdcall CON_getlogfile( void );

void __stdcall CON_clear( void );
void __stdcall CON_print(const char *txt);
void __stdcall CON_print_dbg(const char *txt);
void __stdcall CON_print1(const char *format, ...);
void __stdcall CON_print1_dbg(const char *format, ...);
void CON_printf(const char *format, ...);
void CON_printf_dbg(const char *format, ...);

char * __stdcall CON_data( void );
int __stdcall CON_maxrow( void );
int __stdcall CON_maxcol( void );

int __stdcall CON_resize(int cols, int rows);

#endif
