#ifndef __INCLUDE_JM_GUI_RT_BI__
#define __INCLUDE_JM_GUI_RT_BI__

' -------------------------------------------------------------------
' BASE UI TYPES
' -------------------------------------------------------------------

#ifndef __JM_GUI_BASE_TYPES_DEFINED__
#define __JM_GUI_BASE_TYPES_DEFINED__

Type UI_POINT_T
  x As Integer
  y As Integer
End Type

Type UI_RECT_T
  x As Integer
  y As Integer
  w As Integer
  h As Integer
End Type

Type UI_MSG_DATA_T
  mX As Integer
  mY As Integer
  mW AS Integer
  mB As Integer
  ky As Integer
End Type

Type UI_BOX_PTR As UI_BOX_T Ptr

#define BOXPROC_FUNC_T Function(ByVal this_ As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

Type DSTR as ubyte ptr

Type UI_BOX_T
  Owner As UI_BOX_PTR
  Prev As UI_BOX_PTR
  Next As UI_BOX_PTR
  Child As UI_BOX_PTR
  BoxProc As BOXPROC_FUNC_T
  DefProc As BOXPROC_FUNC_T

  Id As Integer
  rec As UI_RECT_T
  BoxType As Integer

  Flags As Integer
	Style As Integer
  Caption As DSTR
	DataPtr as Any ptr
	ExtraBytes as integer '' Must be last member!!
End Type

#endif '' __JM_GUI_BASE_TYPES_DEFINED__

#endif '' __INCLUDE_JM_GUI_RT_BI__
